/* Datei: lowlevel.c */
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>

int main (void)
{
   int source_fd;
   int dest_fd;
   int zaehler;
   int i;

   struct adresse { char name [30];
                    char ort [30];
                    char strasse [30];
                    long plz;
                  } adr;

   if ((source_fd = open ("source.dat", O_RDONLY)) < 0)
   {
      printf ("Fehler beim Oeffnen der Datei 'source.dat'\n");
      return 1;
   }

   if ((dest_fd = creat ("dest.dat", S_IWUSR | S_IRUSR)) < 0)
   {
      printf ("Fehler beim Erstellen der Datei 'dest.dat'\n");
      return 1;
   }

   /* Zaehler, wieviele Elemente in der Source-Datei sind */
   zaehler = 0;
   while (lseek (source_fd, sizeof (struct adresse),
                 SEEK_CUR) > 0) zaehler++;

   /* Umkopieren der Datensaetze */
   for (i = 0; i < zaehler; i++)
   {
      if(lseek (source_fd,
                (zaehler - i - 1) * sizeof (struct adresse),
                SEEK_SET) < 0)
      {
         printf ("Fehler beim Positionieren in der ");
         printf ("Datei 'source.dat'\n");
         return 1;
      }

      /* Daten aus Source-Datei auslesen */
      if(read (source_fd, &adr, sizeof (struct adresse)) < 0)
      {
         printf ("Fehler beim Lesen aus der Datei 'source.dat'\n");
         return 1;
      }

      /* Daten in Destination-Datei eintragen */
      if (write (dest_fd, &adr, sizeof(struct adresse))
          < sizeof (struct adresse))
      {
         printf ("Fehler beim Schreiben in die Datei 'dest.dat'\n");
         return 1;
      }
   } /* End of for */

   /* Schliessen der geoeffneten Dateien */
   if (close (source_fd) < 0)
   {
      printf ("Fehler beim Schliessen der Datei 'source.dat'\n");
      return 1;
   }
  

   if (close (dest_fd) < 0)
   {
      printf ("Fehler beim Schliessen der Datei 'dest.dat'\n");
      return 1;
   }
   return 0;
}
 
