/* Datei: fread.c */
/* Lesen eines kompletten Arrays aus einer Binaerdatei            */
#include <stdio.h>

int main (void)
{
   float puffer [4];
   int index;
   /* Verwendung der Ausgabedatei aus dem vorherigen Beispiel:    */
   const char * const filename = "..\\fwrite1\\bsp.bin";
   FILE * fp;
   if ((fp = fopen (filename, "rb")) == NULL)
   {
      fprintf (stderr,
         "Fehler beim Oeffnen der Datei %s\n", filename);
      return 1;
   }
   
   /* Die Groesse eines Objektes wird aus Portabilitaetsgruenden  */
   /* stets mit Hilfe von sizeof angegeben.                       */
   if (fread (puffer, sizeof puffer, 1, fp) < 1)
   {
      /* Fehlerbehandlung   */
      fprintf (stderr,
         "Fehler beim binaeren Lesen von Datei %s\n", filename);
      return 2;
   }

   /* Array ausgeben:                                             */
   printf ("Inhalt der Datei %s:\n", filename);
   for (index = 0; index < sizeof (puffer) / sizeof (puffer[0]); 
        index++)
      printf ("%f\n", puffer[index]);
   return 0;
}


