/* Datei: ftell.c */
/* Laenge einer Datei                                             */
#include <stdio.h>

int main (void)
{
   const char * const filename = "ftell.c";
   FILE * fp;
   long len;

   if ((fp = fopen (filename, "r")) == NULL)
   {
      fprintf (stderr,
         "Fehler beim Oeffnen der Datei %s\n", filename);
      return 1;
   }
   /* Positionieren auf letztes Byte:                             */
   if (fseek (fp, 0L, SEEK_END) != 0)
   {  
      fprintf (stderr, "Fehler beim Positionieren mit fseek\n");
      return 2;
   }

   if ((len = ftell (fp)) < 0L)
   {
      fprintf (stderr, "Fehler bei ftell\n");
      return 3;
   }
   fclose (fp);
   printf ("Die Datei %s hat %ld Bytes.\n", filename, len);
   return 0;
}


