/* Datei: fwrite2.c */
/* Schreiben von Strukturen in eine Binaerdatei */
#include <stdio.h>

int main (void)
{
   const char * const filename = "bsp.bin";
   FILE * fp;
   int index;
   struct { int zahlInt;
            long zahlLong;
            char zeichen;
            double zahlDouble;
          } bsp_struct;

   if ((fp = fopen (filename, "wb")) == NULL)
   {
      fprintf (stderr,
         "Fehler beim Oeffnen der Datei %s\n", filename);
      return 1;
   }

   for (index = 0; index < 5; index++)
   {
      bsp_struct.zahlInt = index;
      bsp_struct.zahlLong = index * 100;
      bsp_struct.zeichen = (char)(index + 48);
      bsp_struct.zahlDouble = (double)index * 12.34;

      if (fwrite (&bsp_struct, sizeof(bsp_struct), 1, fp) < 1)
      {
         printf ("Fehler beim Schreiben mit fwrite\n");
         return 2;
      }
   }
   fclose (fp);
   return 0;
}
