/* Datei: hashtab.c                                               */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hashtab.h"

int main (void)
{
   int ind;
   char zeile [40];
   MESSWERT x;
   init_tabelle (tabelle);
   fuelle_tabelle (tabelle);
   ausgeben_tabelle (tabelle);
   
   /* Loeschen von Messgeraeten                                   */
   /* Hier kann ein Messgeraet zum Loeschen ausgewaehlt werden,   */
   /* indem man den Messgeraetenamen eingibt. Wenn Sie keine      */
   /* weiteren Messgeraete mehr loeschen moechten, dann q zum     */
   /* Beenden eingeben.                                           */

   while (printf ("\nZu loeschendes Messgeraet (Ende mit q)= "),        
          gets (zeile), strcmp (zeile, "q"))
   {
      loeschen (zeile, tabelle);
      ausgeben_tabelle (tabelle);
   }
   /* Einfuegen von Messgeraeten                                  */
   /* Hier koennen, freie Tabellenplaetze vorausgesetzt, neue     */
   /* Messgeraete eingefuegt werden. Zum Beenden q eingeben.      */
   
   while (printf ("\nNeuer Messgeraetename (Ende mit q)= "), 
          gets (zeile), strcmp (zeile, "q"))
   {
      ind = hash (zeile);          /* Berechnen der Position      */
      printf ("\nMesswert zu Messgeraet %s eingeben: ", zeile);
      scanf ("%lf", &(x.wert));    /* Eingabe des Messwertes      */
      eingabe_Puffer_loeschen();   /* Eingabepuffer leeren        */
      strcpy (x.name, zeile);      /* ELEMENT X fuellen           */
      einfuegen (x, tabelle);      /* Neues Element in Tabelle    */
                                   /* aufnehmen                   */
      ausgeben_tabelle (tabelle);  /* Tabelle ausgeben            */
   }   
   while (printf ("\nZu suchendes Messgeraet (Ende mit q) = "), 
          gets (zeile), strcmp(zeile, "q"))
   {
      
      if ((ind = suche_schluessel (zeile, tabelle)) != -1)
      {
         printf ("Schluessel = %d, Name = %s, Messwert = %f\n", 
                  hash (zeile), tabelle[ind].name,
                  tabelle[ind].wert);
      }
      else
      {
         printf ("Schluessel %s ist nicht in der Tabelle\n", zeile);
      }
   }
   return 0;
}

int hash (char * name)
{
   int iSummeASCII = 0;
   char * ptrName = name;
   while (*ptrName != '\0')
   {
      iSummeASCII = (int) *ptrName + iSummeASCII;
      ptrName++;
   }
   return (iSummeASCII % GRENZE);
}

int rehash (int schl)
{
   return ((++schl) %GRENZE);
}

int einfuegen (MESSWERT x, MESSWERT * tab)
{
   int ind;
   int z = 0;
   ind = hash (x.name);
   while ((strcmp(tab[ind].name, FREI)) &&
          (strcmp(tab[ind].name, GELOESCHT)))
   {
      if (!(strcmp(tab[ind].name , x.name)))
      {
         printf ("Eintrag bereits in Tabelle\n");
         return 1;
      }
      ind = rehash (ind);
      z++;
      if (z == GRENZE)
      {
         printf ("Tabelle voll\n");
         return 1;
      }
   }
   strcpy (tab[ind].name, x.name);
   tab[ind].wert = x.wert;
   return 0;
}

int loeschen (char * name, MESSWERT * tab)
{
   int ind;
   ind = suche_schluessel (name, tab);
   if (ind != -1)
   {
      strcpy (tab[ind].name, GELOESCHT);
      tab[ind].wert = 0.;
   }
   else
   {
      printf ("Schluessel %s nicht in Tabelle\n", name);
      return 1;
   }
   return 0;
}

int suche_schluessel (char * name, MESSWERT * tab)
{
   int ind;
   int z = 0;
   ind = hash (name);
   while (strcmp(tab[ind].name, name))
   {
      ind = rehash (ind);
      z++;
      if (strcmp(tab[ind].name, FREI) || z == GRENZE)
      {
         return -1;
      }
   }
   return ind;
}

static void init_tabelle (MESSWERT * tab)
{
   int i;
   for (i = 0; i < GRENZE; i++)
   {
      strcpy (tab[i].name, FREI);
      tab[i].wert = 0.;
   }
}

static void fuelle_tabelle (MESSWERT * tab)
{
   int i;
   MESSWERT y;
   
   for (i = 0; i < FUELLWERT; i ++)
   {
      printf ("%d. Messgeraetenamen eingeben: ", (i+1));
      gets (y.name);
      printf ("Messwert zu Messgeraet %s", y.name);
      printf (" eingeben: ");
      scanf ("%lf", &(y.wert));
      eingabe_Puffer_loeschen();
      einfuegen (y, tab);
   }
}

void ausgeben_tabelle (MESSWERT * tabelle)
{
   int i;
   for (i=0; i < GRENZE; i++)
   {
      if (strcmp(tabelle[i].name, FREI))
      {
         printf ("\nSchluessel: %d Name: %s Messwert: %f", 
                 hash (tabelle[i].name), 
                 tabelle[i].name, tabelle[i].wert);
      }
   }
}

void eingabe_Puffer_loeschen (void)
{
   char c;
   do
   {
      c = getchar();
   } while (c != '\n');
}

